/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package mv3302;

import simkit.Entity;
import simkit.random.RandomVariate;

/**
 * CustomerArrivalProcess class acts as the arrival process for the simulation
 * extending the ArrivalProcess class. The class instantiates variables for the
 * ServiceTime, RenegeTime, InterarrivalTime and numberArrivals
 */
public final class CustomerArrivalProcess extends ArrivalProcess {

    private RandomVariate serviceTimeGenerator;

    private RandomVariate renegeTimeGenerator;

    private RandomVariate interarrivalTimeGenerator;

    private int numberofArrivals;

    /**
     * Zero-argument constructor
     */
    public CustomerArrivalProcess() {
        super();
    }
    
    /**
     * Constructor method that instantiates renege times and service times for
     * each customer arrival
     * @param renegeTimeGenerator
     * @param interarrivalTimeGenerator
     * @param serviceTimeGenerator
     */
    public CustomerArrivalProcess(RandomVariate renegeTimeGenerator, RandomVariate interarrivalTimeGenerator, RandomVariate serviceTimeGenerator) {
        super(interarrivalTimeGenerator);
        setServiceTimeGenerator(serviceTimeGenerator);
        setRenegeTimeGenerator(renegeTimeGenerator);
    }

    /**
     * Generates a customers serviceTime, renegeTime, iterates the total number
     * of arrivals and schedules the customers arrival event
     */
    @Override
    public void doArrival() {
        super.doArrival();
        double serviceTime = serviceTimeGenerator.generate();
        double renegeTime = renegeTimeGenerator.generate();
        Customer customer = new Customer(serviceTime, renegeTime);
        waitDelay("Arrival", 0.0, customer);
        numberofArrivals += 1;
    }
/**
     * Does nothing, since this is only to be "heard"
     * @param customer

     */
    public void doArrival(Customer customer) {
    }
    /**
     * @return the serviceTimeGenerator
     */
    public RandomVariate getServiceTimeGenerator() {
        return serviceTimeGenerator;
    }

    /**
     * @param serviceTimeGenerator the serviceTimeGenerator to set
     */
    public void setServiceTimeGenerator(RandomVariate serviceTimeGenerator) {
        this.serviceTimeGenerator = serviceTimeGenerator;
    }

    /**
     * @return the renegeTimeGenerator
     */
    public RandomVariate getRenegeTimeGenerator() {
        return renegeTimeGenerator;
    }

    /**
     * @param renegeTimeGenerator the renegeTimeGenerator to set
     */
    public void setRenegeTimeGenerator(RandomVariate renegeTimeGenerator) {
        this.renegeTimeGenerator = renegeTimeGenerator;
    }

    /**
     * @return the numberArrivals
     */
    @Override
    public int getNumberArrivals() {
        return numberofArrivals;
    }

}
