/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */
package mv3302.run;

import java.awt.geom.Point2D;
import mv3302.SimpleMover;
import mv3302.SimplePathMoverManager;
import mv3302.SimplePatrolMoverManager;
import mv3302.SimpleRandomMoverManager;
import simkit.Schedule;
import simkit.random.RandomVariate;
import simkit.random.RandomVariateFactory;
import simkit.util.SimplePropertyDumper;

/**
 *
 * @author dansl
 */
public class Assignment6 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Point2D initialLocation = new Point2D.Double(0.0, 250.0);
        double maxSpeed = 30.0;

        SimpleMover simpleMover = new SimpleMover(initialLocation, maxSpeed);
        System.out.println(simpleMover);

        Point2D[] path = new Point2D[]{
            new Point2D.Double(-200.0, 0.0),
            new Point2D.Double(-200.0, 250.0),
            new Point2D.Double(200.0, 250.0),
            new Point2D.Double(0.0, 250.0)};

        SimplePathMoverManager simplePathMoverManager = new SimplePathMoverManager(path, true);
        System.out.println(simplePathMoverManager);

        Point2D initialLocation2 = new Point2D.Double(0.0, 150.0);
        double maxSpeed2 = 40.0;
        SimpleMover simpleMover2 = new SimpleMover(initialLocation2, maxSpeed2);
        System.out.println(simpleMover2);

        Point2D[] path2 = new Point2D[]{
            new Point2D.Double(0.0, 300.0),
            new Point2D.Double(0.0, -100.0)};

        SimplePatrolMoverManager simplePatrolMoverManager = new SimplePatrolMoverManager(path2, true);
        System.out.println(simplePatrolMoverManager);

        //        The coordinate generators
        RandomVariate[] coordinateGenerator = new RandomVariate[]{
            RandomVariateFactory.getInstance("Uniform", -250.0, 250.0),
            RandomVariateFactory.getInstance("Uniform", -100, 300.0)
        };
//        Note startOnRun is now true
        SimpleRandomMoverManager simpleRandomMoverManager = new SimpleRandomMoverManager(coordinateGenerator,
                true);
        System.out.println(simpleRandomMoverManager);

        Point2D initialLocation3 = new Point2D.Double(0.0, 0.0);
        double maxSpeed3 = 50.0;
        SimpleMover simpleMover3 = new SimpleMover(initialLocation3, maxSpeed3);
        System.out.println(simpleMover3);

        simpleMover.addSimEventListener(simplePathMoverManager);
        simplePathMoverManager.addSimEventListener(simpleMover);

        simpleMover.addSimEventListener(simplePatrolMoverManager);
        simplePatrolMoverManager.addSimEventListener(simpleMover);

        simpleMover.addSimEventListener(simpleRandomMoverManager);
        simpleRandomMoverManager.addSimEventListener(simpleMover);

        SimplePropertyDumper simplePropertyDumper = new SimplePropertyDumper();
        simpleMover.addPropertyChangeListener(simplePropertyDumper);
        simplePathMoverManager.addPropertyChangeListener(simplePropertyDumper);

        Schedule.setVerbose(true);

        Schedule.stopAtTime(10.5);
        Schedule.reset();
        simpleMover.waitDelay("MoveTo", 0.0);
        simpleMover.waitDelay("OrderStop", 0.1);
        simpleMover.waitDelay("Stop", 0.2);
        simplePatrolMoverManager.waitDelay("Stop", 10.0);
        simpleRandomMoverManager.waitDelay("Stop", 20.0);
        Schedule.startSimulation();
    }

}
